<?
  /*
  *  DRIVER REVERSE HANDLER
  */

class DriverReverseHandler {

  private $USER, $json,
    $USER_ID,
    $reason_msg,
    $elem_id,
    $USER_COMPANY,
    $tender_id,
    $company_id = 0
    ;

  public function __construct($json) {
    global $USER;
    $this->USER = $USER;
    CModule::IncludeModule('iblock');
    $this->json = $json;
  }

  public function run() {
    try {
      $this->checkAuth();

			//     
			if (isset($_REQUEST['time_check']))	return;

      $this->getRequest();
      $this->getBid();
			$this->getTender();
			$this->checkCanReverse();
			$this->reverse();
			$this->notify();
			$this->response();
    } catch (Exception $e) {
      $this->json->setError($e->getMessage());
    }
  }

  //   
  protected function checkAuth() {
    if(!$this->USER->IsAuthorized()) throw new Exception('  !', 1);
    $this->USER_ID = $this->USER->GetID();
  }

  protected function getRequest() {
    //  
    $this->reason_msg = trim($_REQUEST['reverse_reason']);
    if (empty($this->reason_msg)) throw new Exception('   !', 1);

    //  
    $this->elem_id = (int)$_REQUEST['elem_id'];
    if (!$this->elem_id) throw new Exception(' ID ', 1);

    // ,    
    $this->USER_COMPANY = (int)$_SESSION['LOGISTIC_TRANSPORTER_COMPANY'];
    if (!$this->USER_COMPANY) throw new Exception('    ,        ', 1);

  }


  //  . ,    .
  protected function getBid() {
    $arSelect = array('IBLOCK', 'ID', 'PROPERTY_USER_PARENT', 'PROPERTY_TENDER_PARENT');
    $arFilter = array('IBLOCK_ID' => LOGISTIC_TRANSPORTERS_RESPONSE_IBID, 'ID' => $this->elem_id,
      'PROPERTY_USER_PARENT_PARENT' => $this->USER_COMPANY);
    $res = CIBlockElement::GetList(array(), $arFilter, false, array('nPageSize' => 1), $arSelect);
		if($res->SelectedRowsCount() == 0) throw new Exception('   ', 1);

		$this->bid = $res->Fetch();
    $this->tender_id = (int)$this->bid['PROPERTY_TENDER_PARENT_VALUE'];
    $this->company_id = (int)$this->bid['PROPERTY_USER_PARENT'];
		if($this->tender_id == 0) throw new Exception('   ', 1);
  }

	//  
	protected function getTender() {
		$arSelect = array('IBLOCK', 'ID', 'PROPERTY_CHOICE_REQUEST', 'PROPERTY_TENDER_STATUS', 'PROPERTY_LOADING_DISTRICT', 'PROPERTY_UNLOADING_CITY', 'PROPERTY_UNLOADING_ADDRESS',
    'PROPERTY_LOADING_DATE');
		$arFilter = array('IBLOCK_ID' => LOGISTIC_TENDER_REQUEST_IBID, 'ID' => $this->tender_id, 'PROPERTY_CHOICE_REQUEST' => $this->elem_id);
    $res = CIBlockElement::GetList(array(), $arFilter, false, array('nPageSize'=>1), $arSelect);
		if($res->SelectedRowsCount() == 0) throw new Exception('   ', 1);

    $this->tender = $res->Fetch();
	}

	//     
	protected function checkCanReverse() {
		$reverseTimeLimit = strtotime($this->tender['PROPERTY_LOADING_DATE_VALUE']) - 8*3600; // 16   
		$nowTime = strtotime(date('d.m.Y H:i:s'));
		$diff = $reverseTimeLimit - $nowTime;

		if($diff <= 0) throw new Exception('     16:00    !', 1);

		if(!in_array($this->tender['PROPERTY_TENDER_STATUS_ENUM_ID'],
			array(LOGISTIC_STATUS_CLOSE, LOGISTIC_STATUS_OPEN, LOGISTIC_STATUS_DRIVER_APPOINT)))
			throw new Exception('   ', 1);
	}

	protected function reverse() {
		// ,    
		CIBlockElement::SetPropertyValuesEx($this->elem_id, LOGISTIC_TRANSPORTERS_RESPONSE_IBID,
			array('CONFIRMATION' => LOGISTIC_REVERSE, 'REVERSE_REASON' => iconv('UTF-8', 'cp1251', $this->reason_msg)));

		//TODO:    ? ...     
		CIBlockElement::SetPropertyValuesEx($this->tender['ID'], LOGISTIC_TENDER_REQUEST_IBID,
			array('TENDER_STATUS' => LOGISTIC_STATUS_OPEN, 'CHOICE_REQUEST' => '', 'IS_REVERSED' => 'Y', 'PRICE_ACTIVE' => '',
			'DATE_ACTIVE_TO' => date('d.m.Y H:i:s',strtotime(date('d.m.Y H:i:s') . '+60 minutes'))));

		$el = new CIBlockElement;

		//   (,  )
		$arSelect2 = array('IBLOCK', 'ID', 'PROPERTY_TENDER_PARENT');
		$arFilter2 = array('IBLOCK_ID' => LOGISTIC_TRANSPORTERS_RESPONSE_IBID, 'PROPERTY_TENDER_PARENT' => $this->tender['ID'],
			'!=PROPERTY_CONFIRMATION_ENUM_ID' => array('LOGISTIC_REVERSE'));
		$res2 = CIBlockElement::GetList(array(), $arFilter2, false, false, $arSelect2);

		while ($ob2 = $res2->GetNextElement()) {
			$arFields2 = $ob2->GetFields();

			$el2 = new CIBlockElement;
			$arSettings = array('ACTIVE' => 'N');

			$el2->Update($arFields2['ID'], $arSettings);

			CIBlockElement::SetPropertyValuesEx($this->tender_id, LOGISTIC_TENDER_REQUEST_IBID,
				array('TENDER_STATUS' => LOGISTIC_STATUS_OPEN, 'CHOICE_REQUEST' => '')
			);
		}

		IWebLog::AddToLog(LOGISTIC_IWEBLOG_TENDER_STATUS, ' ', $this->tender_id);
	}

	protected function response() {
		//  
		$this->json->addJsonMessage(' ');
		//  
		$this->json->addJsonMethod('driver-reverse', array('ok'=>'ok'));
	}

	protected function notify() {
		$arParams = array();
		$arParams['REQUEST_ID'] = $this->tender['ID'];
		$arParams['NAME'] = getCompanyNameById($this->company_id);
		$arParams['LOADING_ADDRESS'] = getLoadingAddressById($this->tender['PROPERTY_LOADING_DISTRICT']);

		for($i = 0, $m = count($this->tender['PROPERTY_UNLOADING_CITY_VALUE'])-1; $i <= $m; $i++)	{
			$arParams['UNLOADING_ADDRESS'] .= $this->tender['PROPERTY_UNLOADING_CITY_VALUE'][$i] . ' ' . $this->tender['PROPERTY_UNLOADING_ADDRESS_VALUE'][$i];

			if ($i != $m)
				$arParams['UNLOADING_ADDRESS'] .= '; ';
		}

		//      
		MailWrapper::SendMailResponseReverse($arParams);
	}

}

$DriverReverseHandler = new DriverReverseHandler($json);
$DriverReverseHandler->run();
